<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover { 
            background-image: url("images/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">
        
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">  <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"><!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center"> <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="images/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center"> <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="images/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
"use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_DICE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    $(document).ready(function() {
      $("#btn-dice").on("click", onBtnNewDiceClick); // thêm sự kiện cho nút bấm new dice
    });
     // Định nghĩa đối tượng User
     var gUserInfo = {
            username: "",
            firstname: "",
            lastname: ""
    };
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm xử lý khi nhấn nút Ném
    function onBtnNewDiceClick() {
        "use strict";
        //B1: Thu thập dữ liệu
        getDataForm(gUserInfo);
        //B2: Kiểm tra dữ liệu
        var vValidateTrue = validateData(gUserInfo);
        if(vValidateTrue == true) {
            showDataUserToConsole(gUserInfo);
            console.log("Dữ liệu hợp lệ = true");
            var vXmlHttpDice = new XMLHttpRequest();
            //B3: Gọi API
            callAPINewDice(gUserInfo, vXmlHttpDice);
            vXmlHttpDice.onreadystatechange = function() {
                if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log("Response text = ");
                    console.log(vXmlHttpDice.responseText); // ghi chuỗi responseText ra console
                    var vDiceObj = JSON.parse(vXmlHttpDice.responseText); // chuyển chuỗi JSON sang Object
                    // gọi hàm đổi ảnh dice
                    changeDiceImage(vXmlHttpDice);
                    // gọi hàm ghi lời chúc
                    showMessage(vXmlHttpDice);
                    // gọi hàm ghi thông tin voucher id và phần trăm giảm giá
                    showVoucherToForm(vXmlHttpDice);
                    // gọi hàm hiện quà tặng
                    showPresentToForm(vXmlHttpDice);
                }
            }
        }
        else {
            console.log("Dữ liệu không hợp lệ = false");
        }    
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu trên form
    function getDataForm(paramUser) {
        "use strict";
        // truy vấn vào phần tử input trên form
        var vInputUserName = $("#inp-user-name");
        var vInputFirstName = $("#inp-first-name");
        var vInputLastName = $("#inp-last-name");
        // gán giá trị cho đối tượng
        paramUser.username = $.trim(vInputUserName.val());
        paramUser.firstname =$.trim(vInputFirstName.val());
        paramUser.lastname = $.trim(vInputLastName.val());  
    }
    // Hàm kiểm tra dữ liệu thu thập trên form
    function validateData(paramUser) {
        "use strict";
        if(paramUser.username == "") {
            alert("Chưa nhập username");
            return false;
        }
        if(paramUser.firstname == "") {
            alert("Chưa nhập firstname");
            return false;
        }
        if(paramUser.lastname == "") {
            alert("Chưa nhập lastname");
            return false;
        }
        return true;
    }
    // Hàm ghi thông tin User ra console
    function showDataUserToConsole(paramUser){
        "use strict";
        console.log("%c Thông tin đối tượng: ", "color: orange");
        console.log(paramUser);
    }
    // gọi hàm để tung xúc xắc
    function callAPINewDice(paramUser, paramXmlHttp) {
        // chuyển object về chuỗi JSON
        var vUserJsonData = JSON.stringify(paramUser);
        paramXmlHttp.open("POST", gBASE_DICE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXmlHttp.send(vUserJsonData);
    }
    // hàm đổi ảnh tương ứng với số dice
    function changeDiceImage(paramXmlHttp) {
        "use strict";
        var vDiceObj = JSON.parse(paramXmlHttp.responseText);
            var vImageDice = $("#img-dice");// truy vấn phần tử image dice
        if (vDiceObj.dice === 1) {
           vImageDice.attr("src", "images/1.png");
        }
        else if (vDiceObj.dice === 2) {
            vImageDice.attr("src", "images/2.png");
        }
        else if (vDiceObj.dice === 3) {
            vImageDice.attr("src", "images/3.png");
        }
        else if (vDiceObj.dice === 4) {
            vImageDice.attr("src", "images/4.png");
        }
        else if (vDiceObj.dice === 5) {
           vImageDice.attr("src", "images/5.png");
        }
        else if (vDiceObj.dice === 6) {
            vImageDice.attr("src", "images/6.png");
        }
    }
    // Hàm hiển thị lời chúc
    function showMessage(paramXmlHttp){
        "use strict";
        var vDiceObj = JSON.parse(paramXmlHttp.responseText);
        // truy vấn vào phần tử p element
        if (vDiceObj.dice <=3) { // kiểm tra nếu nhỏ hơn bằng 3 thì thông báo An Ủi
            $("#p-notification-dice")
                .css({"display":"block", "color": "purple"})    
                .html("An Ủi");
        }
        else if (vDiceObj.dice >= 4) { // kiểm tra nếu lớn hơn bằng 4 thì thông báo Chúc mừng
            $("#p-notification-dice")
                .css({"display":"block", "color": "orange"})
                .html("Chúc Mừng");
        }
    }
    // Hàm hiển thị voucher và ID
    function showVoucherToForm(paramXmlHttp) {
        "use strict";
        var vDiceObj = JSON.parse(paramXmlHttp.responseText);

        if(vDiceObj.voucher != null) {
            $("#p-voucher-id").html("ID: " + vDiceObj.voucher.id);
            $("#p-voucher-percent").html(vDiceObj.voucher.phanTramGiamGia + "%");
        }
        else {
            $("#p-voucher-id").html("No ID");
            $("#p-voucher-percent").html("0%");
            console.log("Không có voucher");
        }
    }
    // Hàm hiển thị quà tặng
    function showPresentToForm(paramXmlHttp) {
        "use strict";
        var vDiceObj = JSON.parse(paramXmlHttp.responseText);
        // truy vấn vào phần tử img hiển thị quà tặng
        var vImagePresent = $("#img-present");
        if (vDiceObj.prize == null) {
            vImagePresent.attr("src", "LuckyDiceImages/no-present.jpg");
        }
        if(vDiceObj.prize == "Ô tô") {
            vImagePresent.attr("src", "LuckyDiceImages/car.jpg");
        }
        if(vDiceObj.prize == "Xe máy") {
            vImagePresent.attr("src", "LuckyDiceImages/xe-may.jpg");
        }
        if(vDiceObj.prize == "Áo") {
            vImagePresent.attr("src", "LuckyDiceImages/t-shirt.jpg");
        }
        if(vDiceObj.prize == "Mũ") {
            vImagePresent.attr("src", "LuckyDiceImages/hat.jpg");
        }
        if(vDiceObj.prize == "Bút") {
            vImagePresent.attr("src", "LuckyDiceImages/but.jpg");
        }
        if(vDiceObj.prize == "Sổ") {
            vImagePresent.attr("src", "LuckyDiceImages/So.jpg");
        }
    }
</script>

</html>